package com.hfkj.dao;

import com.hfkj.entity.EnDeviceCompanyRel;
import com.hfkj.entity.EnDeviceCompanyRelExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface EnDeviceCompanyRelMapper extends EnDeviceCompanyRelMapperExt {
    @SelectProvider(type=EnDeviceCompanyRelSqlProvider.class, method="countByExample")
    long countByExample(EnDeviceCompanyRelExample example);

    @DeleteProvider(type=EnDeviceCompanyRelSqlProvider.class, method="deleteByExample")
    int deleteByExample(EnDeviceCompanyRelExample example);

    @Delete({
        "delete from en_device_company_rel",
        "where id = #{id,jdbcType=INTEGER}"
    })
    int deleteByPrimaryKey(Integer id);

    @Insert({
        "insert into en_device_company_rel (device_id, company_id, ",
        "`status`, create_user, ",
        "create_user_name, create_time, ",
        "update_user, update_user_name, ",
        "update_time, ext_1, ",
        "ext_2, ext_3)",
        "values (#{deviceId,jdbcType=BIGINT}, #{companyId,jdbcType=BIGINT}, ",
        "#{status,jdbcType=INTEGER}, #{createUser,jdbcType=BIGINT}, ",
        "#{createUserName,jdbcType=VARCHAR}, #{createTime,jdbcType=TIMESTAMP}, ",
        "#{updateUser,jdbcType=BIGINT}, #{updateUserName,jdbcType=VARCHAR}, ",
        "#{updateTime,jdbcType=TIMESTAMP}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(EnDeviceCompanyRel record);

    @InsertProvider(type=EnDeviceCompanyRelSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(EnDeviceCompanyRel record);

    @SelectProvider(type=EnDeviceCompanyRelSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.INTEGER, id=true),
        @Result(column="device_id", property="deviceId", jdbcType=JdbcType.BIGINT),
        @Result(column="company_id", property="companyId", jdbcType=JdbcType.BIGINT),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_user", property="createUser", jdbcType=JdbcType.BIGINT),
        @Result(column="create_user_name", property="createUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_user", property="updateUser", jdbcType=JdbcType.BIGINT),
        @Result(column="update_user_name", property="updateUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<EnDeviceCompanyRel> selectByExample(EnDeviceCompanyRelExample example);

    @Select({
        "select",
        "id, device_id, company_id, `status`, create_user, create_user_name, create_time, ",
        "update_user, update_user_name, update_time, ext_1, ext_2, ext_3",
        "from en_device_company_rel",
        "where id = #{id,jdbcType=INTEGER}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.INTEGER, id=true),
        @Result(column="device_id", property="deviceId", jdbcType=JdbcType.BIGINT),
        @Result(column="company_id", property="companyId", jdbcType=JdbcType.BIGINT),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="create_user", property="createUser", jdbcType=JdbcType.BIGINT),
        @Result(column="create_user_name", property="createUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_user", property="updateUser", jdbcType=JdbcType.BIGINT),
        @Result(column="update_user_name", property="updateUserName", jdbcType=JdbcType.VARCHAR),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    EnDeviceCompanyRel selectByPrimaryKey(Integer id);

    @UpdateProvider(type=EnDeviceCompanyRelSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") EnDeviceCompanyRel record, @Param("example") EnDeviceCompanyRelExample example);

    @UpdateProvider(type=EnDeviceCompanyRelSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") EnDeviceCompanyRel record, @Param("example") EnDeviceCompanyRelExample example);

    @UpdateProvider(type=EnDeviceCompanyRelSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(EnDeviceCompanyRel record);

    @Update({
        "update en_device_company_rel",
        "set device_id = #{deviceId,jdbcType=BIGINT},",
          "company_id = #{companyId,jdbcType=BIGINT},",
          "`status` = #{status,jdbcType=INTEGER},",
          "create_user = #{createUser,jdbcType=BIGINT},",
          "create_user_name = #{createUserName,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_user = #{updateUser,jdbcType=BIGINT},",
          "update_user_name = #{updateUserName,jdbcType=VARCHAR},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=INTEGER}"
    })
    int updateByPrimaryKey(EnDeviceCompanyRel record);
}