package com.hfkj.service.item.impl;

import com.hfkj.dao.EnOilDepotsMapper;
import com.hfkj.entity.EnOilDepots;
import com.hfkj.entity.EnOilDepotsExample;
import com.hfkj.service.item.EnOilDepotsService;
import org.apache.commons.collections4.MapUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Service("enOilDepotsService")
public class EnOilDepotsServiceImpl implements EnOilDepotsService {

    @Resource
    private EnOilDepotsMapper enOilDepotsMapper;

    @Override
    public void create(EnOilDepots enOilDepots) {
        enOilDepotsMapper.insert(enOilDepots);
    }

    @Override
    public void update(EnOilDepots enOilDepots) {
        enOilDepotsMapper.updateByPrimaryKey(enOilDepots);
    }

    @Override
    public void delete(Long id, Boolean fullDelete) {
        if (fullDelete) {
            enOilDepotsMapper.deleteByPrimaryKey(id);
        } else {
            EnOilDepots enOilDepots = queryDetail(id);
            enOilDepots.setStatus(0);
            enOilDepots.setUpdateTime(new Date());
            update(enOilDepots);
        }
    }

    @Override
    public EnOilDepots queryDetail(Long id) {
        return enOilDepotsMapper.selectByPrimaryKey(id);
    }

    @Override
    public EnOilDepots queryDetailByMap(Map<String, Object> map) {
        EnOilDepotsExample example = new EnOilDepotsExample();
        EnOilDepotsExample.Criteria criteria = example.createCriteria();

        if (StringUtils.isNotBlank(MapUtils.getString(map, "contactInfo"))) {
            criteria.andContactInfoLike("%"+MapUtils.getString(map, "contactInfo")+"%");
        }
        if (StringUtils.isNotBlank(MapUtils.getString(map, "oilDepotNo"))) {
            criteria.andOilDepotNoLike("%"+MapUtils.getString(map, "oilDepotNo")+"%");
        }
        if (StringUtils.isNotBlank(MapUtils.getString(map, "oilDepotName"))) {
            criteria.andOilDepotNameLike("%"+MapUtils.getString(map, "oilDepotName")+"%");
        }
        if (StringUtils.isNotBlank(MapUtils.getString(map, "contactPerson"))) {
            criteria.andContactPersonLike("%"+MapUtils.getString(map, "contactPerson")+"%");
        }
        if (MapUtils.getLong(map, "itemId") != null) {
            criteria.andItemIdEqualTo(MapUtils.getLong(map, "itemId"));
        }
        if (MapUtils.getLong(map, "createUser") != null) {
            criteria.andCreateUserEqualTo(MapUtils.getLong(map, "createUser"));
        }
        if (MapUtils.getInteger(map, "status") != null) {
            criteria.andStatusEqualTo(MapUtils.getInteger(map, "status"));
        }else {
            criteria.andStatusNotEqualTo(0);
        }
        if (MapUtils.getLong(map , "id") != null) {
            criteria.andIdEqualTo(MapUtils.getLong(map , "id"));
        }

        List<EnOilDepots> list = enOilDepotsMapper.selectByExample(example);

        return list.isEmpty() ? null : list.get(0);
    }

    @Override
    public List<EnOilDepots> getList(Map<String, Object> map) {
        EnOilDepotsExample example = new EnOilDepotsExample();
        EnOilDepotsExample.Criteria criteria = example.createCriteria();

        if (StringUtils.isNotBlank(MapUtils.getString(map, "contactInfo"))) {
            criteria.andContactInfoLike("%"+MapUtils.getString(map, "contactInfo")+"%");
        }
        if (StringUtils.isNotBlank(MapUtils.getString(map, "oilDepotNo"))) {
            criteria.andOilDepotNoLike("%"+MapUtils.getString(map, "oilDepotNo")+"%");
        }
        if (StringUtils.isNotBlank(MapUtils.getString(map, "oilDepotName"))) {
            criteria.andOilDepotNameLike("%"+MapUtils.getString(map, "oilDepotName")+"%");
        }
        if (StringUtils.isNotBlank(MapUtils.getString(map, "contactPerson"))) {
            criteria.andContactPersonLike("%"+MapUtils.getString(map, "contactPerson")+"%");
        }
        if (MapUtils.getLong(map, "itemId") != null) {
            criteria.andItemIdEqualTo(MapUtils.getLong(map, "itemId"));
        }
        if (MapUtils.getLong(map, "createUser") != null) {
            criteria.andCreateUserEqualTo(MapUtils.getLong(map, "createUser"));
        }
        if (MapUtils.getInteger(map, "status") != null) {
            criteria.andStatusEqualTo(MapUtils.getInteger(map, "status"));
        }else {
            criteria.andStatusNotEqualTo(0);
        }

        return enOilDepotsMapper.selectByExample(example);
    }
}
