package com.hfkj.service.user.impl;

import com.hfkj.dao.BsUserLoginLogMapper;
import com.hfkj.entity.*;
import com.hfkj.service.user.BsUserLoginLogService;
import org.apache.commons.collections4.MapUtils;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @className: BsUserLoginLogServiceImpl
 * @author: HuRui
 * @date: 2024/5/6
 **/
@Service("userLoginLogService")
public class BsUserLoginLogServiceImpl implements BsUserLoginLogService {
    @Resource
    private BsUserLoginLogMapper userLoginLogMapper;

    @Override
    public void create(BsUserLoginLog userLoginLog) {
        userLoginLog.setCreateTime(new Date());
        userLoginLogMapper.insert(userLoginLog);
    }


    @Override
    public List<BsUserLoginLog> getLogList(Map<String, Object> param) {
        BsUserLoginLogExample example = new BsUserLoginLogExample();
        BsUserLoginLogExample.Criteria criteria = example.createCriteria();

        if (MapUtils.getLong(param, "userId") != null) {
            criteria.andUserIdEqualTo(MapUtils.getLong(param, "userId"));
        }

        if (MapUtils.getInteger(param, "status") != null) {
            criteria.andStatusEqualTo(MapUtils.getInteger(param, "status"));
        }

        example.setOrderByClause("create_time desc");
        return userLoginLogMapper.selectByExample(example);
    }

    @Override
    public BsUserLoginLog findUserLog(Long userId) {
        BsUserLoginLogExample example = new BsUserLoginLogExample();
        example.createCriteria().andUserIdEqualTo(userId);
        example.setOrderByClause("create_time desc");

        List<BsUserLoginLog> list = userLoginLogMapper.selectByExample(example);

        if (!list.isEmpty()) {
            return list.get(0);
        }

        return null;
    }
}
